import os, sys, re, string

"""Find orphan and new html or image files. Links within html files must be relative, as produced by eXtrans.
   Parameters: timestampfile roothtmlfile filestocheck
   $Id: reldiff.py,v 1.1.1.1 2004/03/18 11:59:58 gray Exp $"""

def walkinto(htmlfilename):
    """descend recursively html files ; param path must be absolute ; encountered href must be relative"""
    try:
        htmlfile = open(htmlfilename, 'r')
    except:
        print "Error: dead link to non existing", htmlfilename
        return
    htmldir = os.path.dirname(htmlfilename)
    isref[htmlfilename] = os.path.getmtime(htmlfilename) # mark as visited
    while 1:
        data = htmlfile.readline()
        if not data: break
        for reffile in href.findall(data):
            ext = string.split(reffile, '.')[-1]
            apath = os.path.normpath(htmldir+'/'+reffile)
            if ext == "html":
                if not isref.has_key(apath):
                    walkinto(apath)
            else:
                try: isref[apath] = os.path.getmtime(apath)
                except: print "wrong reference in", htmlfilename, ":", apath, "does not exist !"
        # now images
        for reffile in src.findall(data):
            apath = os.path.normpath(htmldir+'/'+reffile)
            if not isref.has_key(apath):
                try: isref[apath] = os.path.getmtime(apath)
                except: print "wrong reference in", htmlfilename, ":", apath, "does not exist !"

def visit(files, dirname, names):
    """called by os.path.walk for each directory it descends into. Used to construct the file
    list to process"""
    for name in names:
        rfpath = dirname+'/'+name
        if not os.path.isdir(rfpath):
            files.append(os.path.abspath(rfpath))

if len(sys.argv) != 4:
    raise "usage: "+sys.argv[0]+" timestampfile roothtmlfile topdirectoryoffilestocheck"

files = [os.path.abspath(sys.argv[2])]
#prefix = os.path.commonprefix(files)
prefix = sys.argv[3]
if prefix[-1] != '/':
    prefix = prefix + '/'
os.path.walk(sys.argv[3], visit, files)
lp = len(prefix)
href = re.compile('(?:HREF|href)\s*=\s*"([\w\-\./]+\.\w+)', re.UNICODE)
src = re.compile('(?:SRC|src)\s*=\s*"([\w\-\./]+\.\w+)', re.UNICODE)
isref = {}


print len(files)-1, "files to check (prefix: %s)" % prefix
reftime = os.path.getmtime(sys.argv[1])
walkinto(files[0])


orphan_files = filter((lambda f, dref=isref: not dref.has_key(f) ), files)
new_files = filter((lambda f, dref=isref, timestamp=reftime: dref[f] > timestamp ), isref.keys())

filelist = open("obsoletefiles.rdiff",'w')
filelist.write("pushd .\ncd %s\n" % prefix)
for of in orphan_files:
    print "obsolete", of
    filelist.write("rm "+of[lp:]+"\n")
filelist.write("popd\n");
filelist.close()

filelist = open("newfiles.rdiff",'w')
filelist.write("cd %s\ntar cvfz kernevez.tgz" % prefix)
for nf in new_files:
    print "new", nf
    filelist.write(" "+nf[lp:])
filelist.write("\nls\n")
filelist.close()

